Skip to content
Primary navigation

Submit tool outputs to run

Deprecated
client.beta.threads.runs.submitToolOutputs(stringrunID, RunSubmitToolOutputsParamsparams, RequestOptionsoptions?): Run { id, assistant_id, cancelled_at, 24 more } | Stream<AssistantStreamEvent>
POST/threads/{thread_id}/runs/{run_id}/submit_tool_outputs

When a run has the status: "requires_action" and required_action.type is submit_tool_outputs, this endpoint can be used to submit the outputs from the tool calls once they're all completed. All outputs must be submitted in a single request.

ParametersExpand Collapse
runID: string
RunSubmitToolOutputsParams = RunSubmitToolOutputsParamsNonStreaming { stream } | RunSubmitToolOutputsParamsStreaming { stream }
RunSubmitToolOutputsParamsBase { thread_id, tool_outputs, stream }
thread_id: string

Path param: The ID of the thread to which this run belongs.

tool_outputs: Array<ToolOutput>

Body param: A list of tools for which the outputs are being submitted.

output?: string

The output of the tool call to be submitted to continue the run.

tool_call_id?: string

The ID of the tool call in the required_action object within the run object the output is being submitted for.

stream?: false | null

Body param: If true, returns a stream of events that happen during the Run as server-sent events, terminating when the Run enters a terminal state with a data: [DONE] message.

RunSubmitToolOutputsParamsNonStreaming extends RunSubmitToolOutputsParamsBase { thread_id, tool_outputs, stream } { stream }
stream?: false | null

Body param: If true, returns a stream of events that happen during the Run as server-sent events, terminating when the Run enters a terminal state with a data: [DONE] message.

RunSubmitToolOutputsParamsStreaming extends RunSubmitToolOutputsParamsBase { thread_id, tool_outputs, stream } { stream }
stream: true

Body param: If true, returns a stream of events that happen during the Run as server-sent events, terminating when the Run enters a terminal state with a data: [DONE] message.

ReturnsExpand Collapse
Run { id, assistant_id, cancelled_at, 24 more }

Represents an execution run on a thread.

id: string

The identifier, which can be referenced in API endpoints.

assistant_id: string

The ID of the assistant used for execution of this run.

cancelled_at: number | null

The Unix timestamp (in seconds) for when the run was cancelled.

completed_at: number | null

The Unix timestamp (in seconds) for when the run was completed.

created_at: number

The Unix timestamp (in seconds) for when the run was created.

expires_at: number | null

The Unix timestamp (in seconds) for when the run will expire.

failed_at: number | null

The Unix timestamp (in seconds) for when the run failed.

incomplete_details: IncompleteDetails | null

Details on why the run is incomplete. Will be null if the run is not incomplete.

reason?: "max_completion_tokens" | "max_prompt_tokens"

The reason why the run is incomplete. This will point to which specific token limit was reached over the course of the run.

One of the following:
"max_completion_tokens"
"max_prompt_tokens"
instructions: string

The instructions that the assistant used for this run.

last_error: LastError | null

The last error associated with this run. Will be null if there are no errors.

code: "server_error" | "rate_limit_exceeded" | "invalid_prompt"

One of server_error, rate_limit_exceeded, or invalid_prompt.

One of the following:
"server_error"
"rate_limit_exceeded"
"invalid_prompt"
message: string

A human-readable description of the error.

max_completion_tokens: number | null

The maximum number of completion tokens specified to have been used over the course of the run.

minimum256
max_prompt_tokens: number | null

The maximum number of prompt tokens specified to have been used over the course of the run.

minimum256
metadata: Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

model: string

The model that the assistant used for this run.

object: "thread.run"

The object type, which is always thread.run.

parallel_tool_calls: boolean

Whether to enable parallel function calling during tool use.

required_action: RequiredAction | null

Details on the action required to continue the run. Will be null if no action is required.

submit_tool_outputs: SubmitToolOutputs { tool_calls }

Details on the tool outputs needed for this run to continue.

tool_calls: Array<RequiredActionFunctionToolCall { id, function, type } >

A list of the relevant tool calls.

id: string

The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the Submit tool outputs to run endpoint.

function: Function { arguments, name }

The function definition.

arguments: string

The arguments that the model expects you to pass to the function.

name: string

The name of the function.

type: "function"

The type of tool call the output is required for. For now, this is always function.

type: "submit_tool_outputs"

For now, this is always submit_tool_outputs.

response_format: AssistantResponseFormatOption | null

Specifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since gpt-3.5-turbo-1106.

Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.

Setting to { "type": "json_object" } enables JSON mode, which ensures the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length.

One of the following:
"auto"
"auto"
ResponseFormatText { type }

Default response format. Used to generate text responses.

type: "text"

The type of response format being defined. Always text.

ResponseFormatJSONObject { type }

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type: "json_object"

The type of response format being defined. Always json_object.

ResponseFormatJSONSchema { json_schema, type }

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

json_schema: JSONSchema { name, description, schema, strict }

Structured Outputs configuration options, including a JSON Schema.

name: string

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the response format is for, used by the model to determine how to respond in the format.

schema?: Record<string, unknown>

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict?: boolean | null

Whether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the schema field. Only a subset of JSON Schema is supported when strict is true. To learn more, read the Structured Outputs guide.

type: "json_schema"

The type of response format being defined. Always json_schema.

started_at: number | null

The Unix timestamp (in seconds) for when the run was started.

status: RunStatus

The status of the run, which can be either queued, in_progress, requires_action, cancelling, cancelled, failed, completed, incomplete, or expired.

One of the following:
"queued"
"in_progress"
"requires_action"
"cancelling"
"cancelled"
"failed"
"completed"
"incomplete"
"expired"
thread_id: string

The ID of the thread that was executed on as a part of this run.

tool_choice: AssistantToolChoiceOption | null

Controls which (if any) tool is called by the model. none means the model will not call any tools and instead generates a message. auto is the default value and means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools before responding to the user. Specifying a particular tool like {"type": "file_search"} or {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.

One of the following:
"none" | "auto" | "required"
"none"
"auto"
"required"
AssistantToolChoice { type, function }

Specifies a tool the model should use. Use to force the model to call a specific tool.

type: "function" | "code_interpreter" | "file_search"

The type of the tool. If type is function, the function name must be set

One of the following:
"function"
"code_interpreter"
"file_search"
function?: AssistantToolChoiceFunction { name }
name: string

The name of the function to call.

tools: Array<AssistantTool>

The list of tools that the assistant used for this run.

One of the following:
CodeInterpreterTool { type }
type: "code_interpreter"

The type of tool being defined: code_interpreter

FileSearchTool { type, file_search }
type: "file_search"

The type of tool being defined: file_search

One of the following:
FunctionTool { function, type }
function: FunctionDefinition { name, description, parameters, strict }
name: string

The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the function does, used by the model to choose when and how to call the function.

parameters?: FunctionParameters

The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.

Omitting parameters defines a function with an empty parameter list.

strict?: boolean | null

Whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. Learn more about Structured Outputs in the function calling guide.

type: "function"

The type of tool being defined: function

truncation_strategy: TruncationStrategy | null

Controls for how a thread will be truncated prior to the run. Use this to control the initial context window of the run.

type: "auto" | "last_messages"

The truncation strategy to use for the thread. The default is auto. If set to last_messages, the thread will be truncated to the n most recent messages in the thread. When set to auto, messages in the middle of the thread will be dropped to fit the context length of the model, max_prompt_tokens.

One of the following:
"auto"
"last_messages"
last_messages?: number | null

The number of most recent messages from the thread when constructing the context for the run.

minimum1
usage: Usage | null

Usage statistics related to the run. This value will be null if the run is not in a terminal state (i.e. in_progress, queued, etc.).

completion_tokens: number

Number of completion tokens used over the course of the run.

prompt_tokens: number

Number of prompt tokens used over the course of the run.

total_tokens: number

Total number of tokens used (prompt + completion).

temperature?: number | null

The sampling temperature used for this run. If not set, defaults to 1.

top_p?: number | null

The nucleus sampling value used for this run. If not set, defaults to 1.

AssistantStreamEvent = ThreadCreated { data, event, enabled } | ThreadRunCreated { data, event } | ThreadRunQueued { data, event } | 21 more

Represents an event emitted when streaming a Run.

Each event in a server-sent events stream has an event and data property:

event: thread.created
data: {"id": "thread_123", "object": "thread", ...}

We emit events whenever a new object is created, transitions to a new state, or is being streamed in parts (deltas). For example, we emit thread.run.created when a new run is created, thread.run.completed when a run completes, and so on. When an Assistant chooses to create a message during a run, we emit a thread.message.created event, a thread.message.in_progress event, many thread.message.delta events, and finally a thread.message.completed event.

We may add additional events over time, so we recommend handling unknown events gracefully in your code. See the Assistants API quickstart to learn how to integrate the Assistants API with streaming.

One of the following:
ThreadCreated { data, event, enabled }

Occurs when a new thread is created.

data: Thread { id, created_at, metadata, 2 more }

Represents a thread that contains messages.

id: string

The identifier, which can be referenced in API endpoints.

created_at: number

The Unix timestamp (in seconds) for when the thread was created.

metadata: Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

object: "thread"

The object type, which is always thread.

tool_resources: ToolResources | null

A set of resources that are made available to the assistant's tools in this thread. The resources are specific to the type of tool. For example, the code_interpreter tool requires a list of file IDs, while the file_search tool requires a list of vector store IDs.

code_interpreter?: CodeInterpreter { file_ids }
file_ids?: Array<string>

A list of file IDs made available to the code_interpreter tool. There can be a maximum of 20 files associated with the tool.

event: "thread.created"
enabled?: boolean

Whether to enable input audio transcription.

ThreadRunCreated { data, event }

Occurs when a new run is created.

data: Run { id, assistant_id, cancelled_at, 24 more }

Represents an execution run on a thread.

id: string

The identifier, which can be referenced in API endpoints.

assistant_id: string

The ID of the assistant used for execution of this run.

cancelled_at: number | null

The Unix timestamp (in seconds) for when the run was cancelled.

completed_at: number | null

The Unix timestamp (in seconds) for when the run was completed.

created_at: number

The Unix timestamp (in seconds) for when the run was created.

expires_at: number | null

The Unix timestamp (in seconds) for when the run will expire.

failed_at: number | null

The Unix timestamp (in seconds) for when the run failed.

incomplete_details: IncompleteDetails | null

Details on why the run is incomplete. Will be null if the run is not incomplete.

reason?: "max_completion_tokens" | "max_prompt_tokens"

The reason why the run is incomplete. This will point to which specific token limit was reached over the course of the run.

One of the following:
"max_completion_tokens"
"max_prompt_tokens"
instructions: string

The instructions that the assistant used for this run.

last_error: LastError | null

The last error associated with this run. Will be null if there are no errors.

code: "server_error" | "rate_limit_exceeded" | "invalid_prompt"

One of server_error, rate_limit_exceeded, or invalid_prompt.

One of the following:
"server_error"
"rate_limit_exceeded"
"invalid_prompt"
message: string

A human-readable description of the error.

max_completion_tokens: number | null

The maximum number of completion tokens specified to have been used over the course of the run.

minimum256
max_prompt_tokens: number | null

The maximum number of prompt tokens specified to have been used over the course of the run.

minimum256
metadata: Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

model: string

The model that the assistant used for this run.

object: "thread.run"

The object type, which is always thread.run.

parallel_tool_calls: boolean

Whether to enable parallel function calling during tool use.

required_action: RequiredAction | null

Details on the action required to continue the run. Will be null if no action is required.

submit_tool_outputs: SubmitToolOutputs { tool_calls }

Details on the tool outputs needed for this run to continue.

tool_calls: Array<RequiredActionFunctionToolCall { id, function, type } >

A list of the relevant tool calls.

id: string

The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the Submit tool outputs to run endpoint.

function: Function { arguments, name }

The function definition.

arguments: string

The arguments that the model expects you to pass to the function.

name: string

The name of the function.

type: "function"

The type of tool call the output is required for. For now, this is always function.

type: "submit_tool_outputs"

For now, this is always submit_tool_outputs.

response_format: AssistantResponseFormatOption | null

Specifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since gpt-3.5-turbo-1106.

Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.

Setting to { "type": "json_object" } enables JSON mode, which ensures the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length.

One of the following:
"auto"
"auto"
ResponseFormatText { type }

Default response format. Used to generate text responses.

type: "text"

The type of response format being defined. Always text.

ResponseFormatJSONObject { type }

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type: "json_object"

The type of response format being defined. Always json_object.

ResponseFormatJSONSchema { json_schema, type }

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

json_schema: JSONSchema { name, description, schema, strict }

Structured Outputs configuration options, including a JSON Schema.

name: string

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the response format is for, used by the model to determine how to respond in the format.

schema?: Record<string, unknown>

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict?: boolean | null

Whether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the schema field. Only a subset of JSON Schema is supported when strict is true. To learn more, read the Structured Outputs guide.

type: "json_schema"

The type of response format being defined. Always json_schema.

started_at: number | null

The Unix timestamp (in seconds) for when the run was started.

status: RunStatus

The status of the run, which can be either queued, in_progress, requires_action, cancelling, cancelled, failed, completed, incomplete, or expired.

One of the following:
"queued"
"in_progress"
"requires_action"
"cancelling"
"cancelled"
"failed"
"completed"
"incomplete"
"expired"
thread_id: string

The ID of the thread that was executed on as a part of this run.

tool_choice: AssistantToolChoiceOption | null

Controls which (if any) tool is called by the model. none means the model will not call any tools and instead generates a message. auto is the default value and means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools before responding to the user. Specifying a particular tool like {"type": "file_search"} or {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.

One of the following:
"none" | "auto" | "required"
"none"
"auto"
"required"
AssistantToolChoice { type, function }

Specifies a tool the model should use. Use to force the model to call a specific tool.

type: "function" | "code_interpreter" | "file_search"

The type of the tool. If type is function, the function name must be set

One of the following:
"function"
"code_interpreter"
"file_search"
function?: AssistantToolChoiceFunction { name }
name: string

The name of the function to call.

tools: Array<AssistantTool>

The list of tools that the assistant used for this run.

One of the following:
CodeInterpreterTool { type }
type: "code_interpreter"

The type of tool being defined: code_interpreter

FileSearchTool { type, file_search }
type: "file_search"

The type of tool being defined: file_search

One of the following:
FunctionTool { function, type }
function: FunctionDefinition { name, description, parameters, strict }
name: string

The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the function does, used by the model to choose when and how to call the function.

parameters?: FunctionParameters

The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.

Omitting parameters defines a function with an empty parameter list.

strict?: boolean | null

Whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. Learn more about Structured Outputs in the function calling guide.

type: "function"

The type of tool being defined: function

truncation_strategy: TruncationStrategy | null

Controls for how a thread will be truncated prior to the run. Use this to control the initial context window of the run.

type: "auto" | "last_messages"

The truncation strategy to use for the thread. The default is auto. If set to last_messages, the thread will be truncated to the n most recent messages in the thread. When set to auto, messages in the middle of the thread will be dropped to fit the context length of the model, max_prompt_tokens.

One of the following:
"auto"
"last_messages"
last_messages?: number | null

The number of most recent messages from the thread when constructing the context for the run.

minimum1
usage: Usage | null

Usage statistics related to the run. This value will be null if the run is not in a terminal state (i.e. in_progress, queued, etc.).

completion_tokens: number

Number of completion tokens used over the course of the run.

prompt_tokens: number

Number of prompt tokens used over the course of the run.

total_tokens: number

Total number of tokens used (prompt + completion).

temperature?: number | null

The sampling temperature used for this run. If not set, defaults to 1.

top_p?: number | null

The nucleus sampling value used for this run. If not set, defaults to 1.

event: "thread.run.created"
ThreadRunQueued { data, event }

Occurs when a run moves to a queued status.

data: Run { id, assistant_id, cancelled_at, 24 more }

Represents an execution run on a thread.

id: string

The identifier, which can be referenced in API endpoints.

assistant_id: string

The ID of the assistant used for execution of this run.

cancelled_at: number | null

The Unix timestamp (in seconds) for when the run was cancelled.

completed_at: number | null

The Unix timestamp (in seconds) for when the run was completed.

created_at: number

The Unix timestamp (in seconds) for when the run was created.

expires_at: number | null

The Unix timestamp (in seconds) for when the run will expire.

failed_at: number | null

The Unix timestamp (in seconds) for when the run failed.

incomplete_details: IncompleteDetails | null

Details on why the run is incomplete. Will be null if the run is not incomplete.

reason?: "max_completion_tokens" | "max_prompt_tokens"

The reason why the run is incomplete. This will point to which specific token limit was reached over the course of the run.

One of the following:
"max_completion_tokens"
"max_prompt_tokens"
instructions: string

The instructions that the assistant used for this run.

last_error: LastError | null

The last error associated with this run. Will be null if there are no errors.

code: "server_error" | "rate_limit_exceeded" | "invalid_prompt"

One of server_error, rate_limit_exceeded, or invalid_prompt.

One of the following:
"server_error"
"rate_limit_exceeded"
"invalid_prompt"
message: string

A human-readable description of the error.

max_completion_tokens: number | null

The maximum number of completion tokens specified to have been used over the course of the run.

minimum256
max_prompt_tokens: number | null

The maximum number of prompt tokens specified to have been used over the course of the run.

minimum256
metadata: Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

model: string

The model that the assistant used for this run.

object: "thread.run"

The object type, which is always thread.run.

parallel_tool_calls: boolean

Whether to enable parallel function calling during tool use.

required_action: RequiredAction | null

Details on the action required to continue the run. Will be null if no action is required.

submit_tool_outputs: SubmitToolOutputs { tool_calls }

Details on the tool outputs needed for this run to continue.

tool_calls: Array<RequiredActionFunctionToolCall { id, function, type } >

A list of the relevant tool calls.

id: string

The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the Submit tool outputs to run endpoint.

function: Function { arguments, name }

The function definition.

arguments: string

The arguments that the model expects you to pass to the function.

name: string

The name of the function.

type: "function"

The type of tool call the output is required for. For now, this is always function.

type: "submit_tool_outputs"

For now, this is always submit_tool_outputs.

response_format: AssistantResponseFormatOption | null

Specifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since gpt-3.5-turbo-1106.

Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.

Setting to { "type": "json_object" } enables JSON mode, which ensures the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length.

One of the following:
"auto"
"auto"
ResponseFormatText { type }

Default response format. Used to generate text responses.

type: "text"

The type of response format being defined. Always text.

ResponseFormatJSONObject { type }

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type: "json_object"

The type of response format being defined. Always json_object.

ResponseFormatJSONSchema { json_schema, type }

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

json_schema: JSONSchema { name, description, schema, strict }

Structured Outputs configuration options, including a JSON Schema.

name: string

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the response format is for, used by the model to determine how to respond in the format.

schema?: Record<string, unknown>

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict?: boolean | null

Whether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the schema field. Only a subset of JSON Schema is supported when strict is true. To learn more, read the Structured Outputs guide.

type: "json_schema"

The type of response format being defined. Always json_schema.

started_at: number | null

The Unix timestamp (in seconds) for when the run was started.

status: RunStatus

The status of the run, which can be either queued, in_progress, requires_action, cancelling, cancelled, failed, completed, incomplete, or expired.

One of the following:
"queued"
"in_progress"
"requires_action"
"cancelling"
"cancelled"
"failed"
"completed"
"incomplete"
"expired"
thread_id: string

The ID of the thread that was executed on as a part of this run.

tool_choice: AssistantToolChoiceOption | null

Controls which (if any) tool is called by the model. none means the model will not call any tools and instead generates a message. auto is the default value and means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools before responding to the user. Specifying a particular tool like {"type": "file_search"} or {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.

One of the following:
"none" | "auto" | "required"
"none"
"auto"
"required"
AssistantToolChoice { type, function }

Specifies a tool the model should use. Use to force the model to call a specific tool.

type: "function" | "code_interpreter" | "file_search"

The type of the tool. If type is function, the function name must be set

One of the following:
"function"
"code_interpreter"
"file_search"
function?: AssistantToolChoiceFunction { name }
name: string

The name of the function to call.

tools: Array<AssistantTool>

The list of tools that the assistant used for this run.

One of the following:
CodeInterpreterTool { type }
type: "code_interpreter"

The type of tool being defined: code_interpreter

FileSearchTool { type, file_search }
type: "file_search"

The type of tool being defined: file_search

One of the following:
FunctionTool { function, type }
function: FunctionDefinition { name, description, parameters, strict }
name: string

The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the function does, used by the model to choose when and how to call the function.

parameters?: FunctionParameters

The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.

Omitting parameters defines a function with an empty parameter list.

strict?: boolean | null

Whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. Learn more about Structured Outputs in the function calling guide.

type: "function"

The type of tool being defined: function

truncation_strategy: TruncationStrategy | null

Controls for how a thread will be truncated prior to the run. Use this to control the initial context window of the run.

type: "auto" | "last_messages"

The truncation strategy to use for the thread. The default is auto. If set to last_messages, the thread will be truncated to the n most recent messages in the thread. When set to auto, messages in the middle of the thread will be dropped to fit the context length of the model, max_prompt_tokens.

One of the following:
"auto"
"last_messages"
last_messages?: number | null

The number of most recent messages from the thread when constructing the context for the run.

minimum1
usage: Usage | null

Usage statistics related to the run. This value will be null if the run is not in a terminal state (i.e. in_progress, queued, etc.).

completion_tokens: number

Number of completion tokens used over the course of the run.

prompt_tokens: number

Number of prompt tokens used over the course of the run.

total_tokens: number

Total number of tokens used (prompt + completion).

temperature?: number | null

The sampling temperature used for this run. If not set, defaults to 1.

top_p?: number | null

The nucleus sampling value used for this run. If not set, defaults to 1.

event: "thread.run.queued"
ThreadRunInProgress { data, event }

Occurs when a run moves to an in_progress status.

data: Run { id, assistant_id, cancelled_at, 24 more }

Represents an execution run on a thread.

id: string

The identifier, which can be referenced in API endpoints.

assistant_id: string

The ID of the assistant used for execution of this run.

cancelled_at: number | null

The Unix timestamp (in seconds) for when the run was cancelled.

completed_at: number | null

The Unix timestamp (in seconds) for when the run was completed.

created_at: number

The Unix timestamp (in seconds) for when the run was created.

expires_at: number | null

The Unix timestamp (in seconds) for when the run will expire.

failed_at: number | null

The Unix timestamp (in seconds) for when the run failed.

incomplete_details: IncompleteDetails | null

Details on why the run is incomplete. Will be null if the run is not incomplete.

reason?: "max_completion_tokens" | "max_prompt_tokens"

The reason why the run is incomplete. This will point to which specific token limit was reached over the course of the run.

One of the following:
"max_completion_tokens"
"max_prompt_tokens"
instructions: string

The instructions that the assistant used for this run.

last_error: LastError | null

The last error associated with this run. Will be null if there are no errors.

code: "server_error" | "rate_limit_exceeded" | "invalid_prompt"

One of server_error, rate_limit_exceeded, or invalid_prompt.

One of the following:
"server_error"
"rate_limit_exceeded"
"invalid_prompt"
message: string

A human-readable description of the error.

max_completion_tokens: number | null

The maximum number of completion tokens specified to have been used over the course of the run.

minimum256
max_prompt_tokens: number | null

The maximum number of prompt tokens specified to have been used over the course of the run.

minimum256
metadata: Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

model: string

The model that the assistant used for this run.

object: "thread.run"

The object type, which is always thread.run.

parallel_tool_calls: boolean

Whether to enable parallel function calling during tool use.

required_action: RequiredAction | null

Details on the action required to continue the run. Will be null if no action is required.

submit_tool_outputs: SubmitToolOutputs { tool_calls }

Details on the tool outputs needed for this run to continue.

tool_calls: Array<RequiredActionFunctionToolCall { id, function, type } >

A list of the relevant tool calls.

id: string

The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the Submit tool outputs to run endpoint.

function: Function { arguments, name }

The function definition.

arguments: string

The arguments that the model expects you to pass to the function.

name: string

The name of the function.

type: "function"

The type of tool call the output is required for. For now, this is always function.

type: "submit_tool_outputs"

For now, this is always submit_tool_outputs.

response_format: AssistantResponseFormatOption | null

Specifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since gpt-3.5-turbo-1106.

Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.

Setting to { "type": "json_object" } enables JSON mode, which ensures the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length.

One of the following:
"auto"
"auto"
ResponseFormatText { type }

Default response format. Used to generate text responses.

type: "text"

The type of response format being defined. Always text.

ResponseFormatJSONObject { type }

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type: "json_object"

The type of response format being defined. Always json_object.

ResponseFormatJSONSchema { json_schema, type }

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

json_schema: JSONSchema { name, description, schema, strict }

Structured Outputs configuration options, including a JSON Schema.

name: string

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the response format is for, used by the model to determine how to respond in the format.

schema?: Record<string, unknown>

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict?: boolean | null

Whether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the schema field. Only a subset of JSON Schema is supported when strict is true. To learn more, read the Structured Outputs guide.

type: "json_schema"

The type of response format being defined. Always json_schema.

started_at: number | null

The Unix timestamp (in seconds) for when the run was started.

status: RunStatus

The status of the run, which can be either queued, in_progress, requires_action, cancelling, cancelled, failed, completed, incomplete, or expired.

One of the following:
"queued"
"in_progress"
"requires_action"
"cancelling"
"cancelled"
"failed"
"completed"
"incomplete"
"expired"
thread_id: string

The ID of the thread that was executed on as a part of this run.

tool_choice: AssistantToolChoiceOption | null

Controls which (if any) tool is called by the model. none means the model will not call any tools and instead generates a message. auto is the default value and means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools before responding to the user. Specifying a particular tool like {"type": "file_search"} or {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.

One of the following:
"none" | "auto" | "required"
"none"
"auto"
"required"
AssistantToolChoice { type, function }

Specifies a tool the model should use. Use to force the model to call a specific tool.

type: "function" | "code_interpreter" | "file_search"

The type of the tool. If type is function, the function name must be set

One of the following:
"function"
"code_interpreter"
"file_search"
function?: AssistantToolChoiceFunction { name }
name: string

The name of the function to call.

tools: Array<AssistantTool>

The list of tools that the assistant used for this run.

One of the following:
CodeInterpreterTool { type }
type: "code_interpreter"

The type of tool being defined: code_interpreter

FileSearchTool { type, file_search }
type: "file_search"

The type of tool being defined: file_search

One of the following:
FunctionTool { function, type }
function: FunctionDefinition { name, description, parameters, strict }
name: string

The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the function does, used by the model to choose when and how to call the function.

parameters?: FunctionParameters

The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.

Omitting parameters defines a function with an empty parameter list.

strict?: boolean | null

Whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. Learn more about Structured Outputs in the function calling guide.

type: "function"

The type of tool being defined: function

truncation_strategy: TruncationStrategy | null

Controls for how a thread will be truncated prior to the run. Use this to control the initial context window of the run.

type: "auto" | "last_messages"

The truncation strategy to use for the thread. The default is auto. If set to last_messages, the thread will be truncated to the n most recent messages in the thread. When set to auto, messages in the middle of the thread will be dropped to fit the context length of the model, max_prompt_tokens.

One of the following:
"auto"
"last_messages"
last_messages?: number | null

The number of most recent messages from the thread when constructing the context for the run.

minimum1
usage: Usage | null

Usage statistics related to the run. This value will be null if the run is not in a terminal state (i.e. in_progress, queued, etc.).

completion_tokens: number

Number of completion tokens used over the course of the run.

prompt_tokens: number

Number of prompt tokens used over the course of the run.

total_tokens: number

Total number of tokens used (prompt + completion).

temperature?: number | null

The sampling temperature used for this run. If not set, defaults to 1.

top_p?: number | null

The nucleus sampling value used for this run. If not set, defaults to 1.

event: "thread.run.in_progress"
ThreadRunRequiresAction { data, event }

Occurs when a run moves to a requires_action status.

data: Run { id, assistant_id, cancelled_at, 24 more }

Represents an execution run on a thread.

id: string

The identifier, which can be referenced in API endpoints.

assistant_id: string

The ID of the assistant used for execution of this run.

cancelled_at: number | null

The Unix timestamp (in seconds) for when the run was cancelled.

completed_at: number | null

The Unix timestamp (in seconds) for when the run was completed.

created_at: number

The Unix timestamp (in seconds) for when the run was created.

expires_at: number | null

The Unix timestamp (in seconds) for when the run will expire.

failed_at: number | null

The Unix timestamp (in seconds) for when the run failed.

incomplete_details: IncompleteDetails | null

Details on why the run is incomplete. Will be null if the run is not incomplete.

reason?: "max_completion_tokens" | "max_prompt_tokens"

The reason why the run is incomplete. This will point to which specific token limit was reached over the course of the run.

One of the following:
"max_completion_tokens"
"max_prompt_tokens"
instructions: string

The instructions that the assistant used for this run.

last_error: LastError | null

The last error associated with this run. Will be null if there are no errors.

code: "server_error" | "rate_limit_exceeded" | "invalid_prompt"

One of server_error, rate_limit_exceeded, or invalid_prompt.

One of the following:
"server_error"
"rate_limit_exceeded"
"invalid_prompt"
message: string

A human-readable description of the error.

max_completion_tokens: number | null

The maximum number of completion tokens specified to have been used over the course of the run.

minimum256
max_prompt_tokens: number | null

The maximum number of prompt tokens specified to have been used over the course of the run.

minimum256
metadata: Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

model: string

The model that the assistant used for this run.

object: "thread.run"

The object type, which is always thread.run.

parallel_tool_calls: boolean

Whether to enable parallel function calling during tool use.

required_action: RequiredAction | null

Details on the action required to continue the run. Will be null if no action is required.

submit_tool_outputs: SubmitToolOutputs { tool_calls }

Details on the tool outputs needed for this run to continue.

tool_calls: Array<RequiredActionFunctionToolCall { id, function, type } >

A list of the relevant tool calls.

id: string

The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the Submit tool outputs to run endpoint.

function: Function { arguments, name }

The function definition.

arguments: string

The arguments that the model expects you to pass to the function.

name: string

The name of the function.

type: "function"

The type of tool call the output is required for. For now, this is always function.

type: "submit_tool_outputs"

For now, this is always submit_tool_outputs.

response_format: AssistantResponseFormatOption | null

Specifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since gpt-3.5-turbo-1106.

Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.

Setting to { "type": "json_object" } enables JSON mode, which ensures the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length.

One of the following:
"auto"
"auto"
ResponseFormatText { type }

Default response format. Used to generate text responses.

type: "text"

The type of response format being defined. Always text.

ResponseFormatJSONObject { type }

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type: "json_object"

The type of response format being defined. Always json_object.

ResponseFormatJSONSchema { json_schema, type }

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

json_schema: JSONSchema { name, description, schema, strict }

Structured Outputs configuration options, including a JSON Schema.

name: string

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the response format is for, used by the model to determine how to respond in the format.

schema?: Record<string, unknown>

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict?: boolean | null

Whether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the schema field. Only a subset of JSON Schema is supported when strict is true. To learn more, read the Structured Outputs guide.

type: "json_schema"

The type of response format being defined. Always json_schema.

started_at: number | null

The Unix timestamp (in seconds) for when the run was started.

status: RunStatus

The status of the run, which can be either queued, in_progress, requires_action, cancelling, cancelled, failed, completed, incomplete, or expired.

One of the following:
"queued"
"in_progress"
"requires_action"
"cancelling"
"cancelled"
"failed"
"completed"
"incomplete"
"expired"
thread_id: string

The ID of the thread that was executed on as a part of this run.

tool_choice: AssistantToolChoiceOption | null

Controls which (if any) tool is called by the model. none means the model will not call any tools and instead generates a message. auto is the default value and means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools before responding to the user. Specifying a particular tool like {"type": "file_search"} or {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.

One of the following:
"none" | "auto" | "required"
"none"
"auto"
"required"
AssistantToolChoice { type, function }

Specifies a tool the model should use. Use to force the model to call a specific tool.

type: "function" | "code_interpreter" | "file_search"

The type of the tool. If type is function, the function name must be set

One of the following:
"function"
"code_interpreter"
"file_search"
function?: AssistantToolChoiceFunction { name }
name: string

The name of the function to call.

tools: Array<AssistantTool>

The list of tools that the assistant used for this run.

One of the following:
CodeInterpreterTool { type }
type: "code_interpreter"

The type of tool being defined: code_interpreter

FileSearchTool { type, file_search }
type: "file_search"

The type of tool being defined: file_search

One of the following:
FunctionTool { function, type }
function: FunctionDefinition { name, description, parameters, strict }
name: string

The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the function does, used by the model to choose when and how to call the function.

parameters?: FunctionParameters

The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.

Omitting parameters defines a function with an empty parameter list.

strict?: boolean | null

Whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. Learn more about Structured Outputs in the function calling guide.

type: "function"

The type of tool being defined: function

truncation_strategy: TruncationStrategy | null

Controls for how a thread will be truncated prior to the run. Use this to control the initial context window of the run.

type: "auto" | "last_messages"

The truncation strategy to use for the thread. The default is auto. If set to last_messages, the thread will be truncated to the n most recent messages in the thread. When set to auto, messages in the middle of the thread will be dropped to fit the context length of the model, max_prompt_tokens.

One of the following:
"auto"
"last_messages"
last_messages?: number | null

The number of most recent messages from the thread when constructing the context for the run.

minimum1
usage: Usage | null

Usage statistics related to the run. This value will be null if the run is not in a terminal state (i.e. in_progress, queued, etc.).

completion_tokens: number

Number of completion tokens used over the course of the run.

prompt_tokens: number

Number of prompt tokens used over the course of the run.

total_tokens: number

Total number of tokens used (prompt + completion).

temperature?: number | null

The sampling temperature used for this run. If not set, defaults to 1.

top_p?: number | null

The nucleus sampling value used for this run. If not set, defaults to 1.

event: "thread.run.requires_action"
ThreadRunCompleted { data, event }

Occurs when a run is completed.

data: Run { id, assistant_id, cancelled_at, 24 more }

Represents an execution run on a thread.

id: string

The identifier, which can be referenced in API endpoints.

assistant_id: string

The ID of the assistant used for execution of this run.

cancelled_at: number | null

The Unix timestamp (in seconds) for when the run was cancelled.

completed_at: number | null

The Unix timestamp (in seconds) for when the run was completed.

created_at: number

The Unix timestamp (in seconds) for when the run was created.

expires_at: number | null

The Unix timestamp (in seconds) for when the run will expire.

failed_at: number | null

The Unix timestamp (in seconds) for when the run failed.

incomplete_details: IncompleteDetails | null

Details on why the run is incomplete. Will be null if the run is not incomplete.

reason?: "max_completion_tokens" | "max_prompt_tokens"

The reason why the run is incomplete. This will point to which specific token limit was reached over the course of the run.

One of the following:
"max_completion_tokens"
"max_prompt_tokens"
instructions: string

The instructions that the assistant used for this run.

last_error: LastError | null

The last error associated with this run. Will be null if there are no errors.

code: "server_error" | "rate_limit_exceeded" | "invalid_prompt"

One of server_error, rate_limit_exceeded, or invalid_prompt.

One of the following:
"server_error"
"rate_limit_exceeded"
"invalid_prompt"
message: string

A human-readable description of the error.

max_completion_tokens: number | null

The maximum number of completion tokens specified to have been used over the course of the run.

minimum256
max_prompt_tokens: number | null

The maximum number of prompt tokens specified to have been used over the course of the run.

minimum256
metadata: Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

model: string

The model that the assistant used for this run.

object: "thread.run"

The object type, which is always thread.run.

parallel_tool_calls: boolean

Whether to enable parallel function calling during tool use.

required_action: RequiredAction | null

Details on the action required to continue the run. Will be null if no action is required.

submit_tool_outputs: SubmitToolOutputs { tool_calls }

Details on the tool outputs needed for this run to continue.

tool_calls: Array<RequiredActionFunctionToolCall { id, function, type } >

A list of the relevant tool calls.

id: string

The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the Submit tool outputs to run endpoint.

function: Function { arguments, name }

The function definition.

arguments: string

The arguments that the model expects you to pass to the function.

name: string

The name of the function.

type: "function"

The type of tool call the output is required for. For now, this is always function.

type: "submit_tool_outputs"

For now, this is always submit_tool_outputs.

response_format: AssistantResponseFormatOption | null

Specifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since gpt-3.5-turbo-1106.

Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.

Setting to { "type": "json_object" } enables JSON mode, which ensures the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length.

One of the following:
"auto"
"auto"
ResponseFormatText { type }

Default response format. Used to generate text responses.

type: "text"

The type of response format being defined. Always text.

ResponseFormatJSONObject { type }

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type: "json_object"

The type of response format being defined. Always json_object.

ResponseFormatJSONSchema { json_schema, type }

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

json_schema: JSONSchema { name, description, schema, strict }

Structured Outputs configuration options, including a JSON Schema.

name: string

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the response format is for, used by the model to determine how to respond in the format.

schema?: Record<string, unknown>

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict?: boolean | null

Whether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the schema field. Only a subset of JSON Schema is supported when strict is true. To learn more, read the Structured Outputs guide.

type: "json_schema"

The type of response format being defined. Always json_schema.

started_at: number | null

The Unix timestamp (in seconds) for when the run was started.

status: RunStatus

The status of the run, which can be either queued, in_progress, requires_action, cancelling, cancelled, failed, completed, incomplete, or expired.

One of the following:
"queued"
"in_progress"
"requires_action"
"cancelling"
"cancelled"
"failed"
"completed"
"incomplete"
"expired"
thread_id: string

The ID of the thread that was executed on as a part of this run.

tool_choice: AssistantToolChoiceOption | null

Controls which (if any) tool is called by the model. none means the model will not call any tools and instead generates a message. auto is the default value and means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools before responding to the user. Specifying a particular tool like {"type": "file_search"} or {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.

One of the following:
"none" | "auto" | "required"
"none"
"auto"
"required"
AssistantToolChoice { type, function }

Specifies a tool the model should use. Use to force the model to call a specific tool.

type: "function" | "code_interpreter" | "file_search"

The type of the tool. If type is function, the function name must be set

One of the following:
"function"
"code_interpreter"
"file_search"
function?: AssistantToolChoiceFunction { name }
name: string

The name of the function to call.

tools: Array<AssistantTool>

The list of tools that the assistant used for this run.

One of the following:
CodeInterpreterTool { type }
type: "code_interpreter"

The type of tool being defined: code_interpreter

FileSearchTool { type, file_search }
type: "file_search"

The type of tool being defined: file_search

One of the following:
FunctionTool { function, type }
function: FunctionDefinition { name, description, parameters, strict }
name: string

The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the function does, used by the model to choose when and how to call the function.

parameters?: FunctionParameters

The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.

Omitting parameters defines a function with an empty parameter list.

strict?: boolean | null

Whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. Learn more about Structured Outputs in the function calling guide.

type: "function"

The type of tool being defined: function

truncation_strategy: TruncationStrategy | null

Controls for how a thread will be truncated prior to the run. Use this to control the initial context window of the run.

type: "auto" | "last_messages"

The truncation strategy to use for the thread. The default is auto. If set to last_messages, the thread will be truncated to the n most recent messages in the thread. When set to auto, messages in the middle of the thread will be dropped to fit the context length of the model, max_prompt_tokens.

One of the following:
"auto"
"last_messages"
last_messages?: number | null

The number of most recent messages from the thread when constructing the context for the run.

minimum1
usage: Usage | null

Usage statistics related to the run. This value will be null if the run is not in a terminal state (i.e. in_progress, queued, etc.).

completion_tokens: number

Number of completion tokens used over the course of the run.

prompt_tokens: number

Number of prompt tokens used over the course of the run.

total_tokens: number

Total number of tokens used (prompt + completion).

temperature?: number | null

The sampling temperature used for this run. If not set, defaults to 1.

top_p?: number | null

The nucleus sampling value used for this run. If not set, defaults to 1.

event: "thread.run.completed"
ThreadRunIncomplete { data, event }

Occurs when a run ends with status incomplete.

data: Run { id, assistant_id, cancelled_at, 24 more }

Represents an execution run on a thread.

id: string

The identifier, which can be referenced in API endpoints.

assistant_id: string

The ID of the assistant used for execution of this run.

cancelled_at: number | null

The Unix timestamp (in seconds) for when the run was cancelled.

completed_at: number | null

The Unix timestamp (in seconds) for when the run was completed.

created_at: number

The Unix timestamp (in seconds) for when the run was created.

expires_at: number | null

The Unix timestamp (in seconds) for when the run will expire.

failed_at: number | null

The Unix timestamp (in seconds) for when the run failed.

incomplete_details: IncompleteDetails | null

Details on why the run is incomplete. Will be null if the run is not incomplete.

reason?: "max_completion_tokens" | "max_prompt_tokens"

The reason why the run is incomplete. This will point to which specific token limit was reached over the course of the run.

One of the following:
"max_completion_tokens"
"max_prompt_tokens"
instructions: string

The instructions that the assistant used for this run.

last_error: LastError | null

The last error associated with this run. Will be null if there are no errors.

code: "server_error" | "rate_limit_exceeded" | "invalid_prompt"

One of server_error, rate_limit_exceeded, or invalid_prompt.

One of the following:
"server_error"
"rate_limit_exceeded"
"invalid_prompt"
message: string

A human-readable description of the error.

max_completion_tokens: number | null

The maximum number of completion tokens specified to have been used over the course of the run.

minimum256
max_prompt_tokens: number | null

The maximum number of prompt tokens specified to have been used over the course of the run.

minimum256
metadata: Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

model: string

The model that the assistant used for this run.

object: "thread.run"

The object type, which is always thread.run.

parallel_tool_calls: boolean

Whether to enable parallel function calling during tool use.

required_action: RequiredAction | null

Details on the action required to continue the run. Will be null if no action is required.

submit_tool_outputs: SubmitToolOutputs { tool_calls }

Details on the tool outputs needed for this run to continue.

tool_calls: Array<RequiredActionFunctionToolCall { id, function, type } >

A list of the relevant tool calls.

id: string

The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the Submit tool outputs to run endpoint.

function: Function { arguments, name }

The function definition.

arguments: string

The arguments that the model expects you to pass to the function.

name: string

The name of the function.

type: "function"

The type of tool call the output is required for. For now, this is always function.

type: "submit_tool_outputs"

For now, this is always submit_tool_outputs.

response_format: AssistantResponseFormatOption | null

Specifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since gpt-3.5-turbo-1106.

Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.

Setting to { "type": "json_object" } enables JSON mode, which ensures the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length.

One of the following:
"auto"
"auto"
ResponseFormatText { type }

Default response format. Used to generate text responses.

type: "text"

The type of response format being defined. Always text.

ResponseFormatJSONObject { type }

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type: "json_object"

The type of response format being defined. Always json_object.

ResponseFormatJSONSchema { json_schema, type }

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

json_schema: JSONSchema { name, description, schema, strict }

Structured Outputs configuration options, including a JSON Schema.

name: string

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the response format is for, used by the model to determine how to respond in the format.

schema?: Record<string, unknown>

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict?: boolean | null

Whether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the schema field. Only a subset of JSON Schema is supported when strict is true. To learn more, read the Structured Outputs guide.

type: "json_schema"

The type of response format being defined. Always json_schema.

started_at: number | null

The Unix timestamp (in seconds) for when the run was started.

status: RunStatus

The status of the run, which can be either queued, in_progress, requires_action, cancelling, cancelled, failed, completed, incomplete, or expired.

One of the following:
"queued"
"in_progress"
"requires_action"
"cancelling"
"cancelled"
"failed"
"completed"
"incomplete"
"expired"
thread_id: string

The ID of the thread that was executed on as a part of this run.

tool_choice: AssistantToolChoiceOption | null

Controls which (if any) tool is called by the model. none means the model will not call any tools and instead generates a message. auto is the default value and means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools before responding to the user. Specifying a particular tool like {"type": "file_search"} or {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.

One of the following:
"none" | "auto" | "required"
"none"
"auto"
"required"
AssistantToolChoice { type, function }

Specifies a tool the model should use. Use to force the model to call a specific tool.

type: "function" | "code_interpreter" | "file_search"

The type of the tool. If type is function, the function name must be set

One of the following:
"function"
"code_interpreter"
"file_search"
function?: AssistantToolChoiceFunction { name }
name: string

The name of the function to call.

tools: Array<AssistantTool>

The list of tools that the assistant used for this run.

One of the following:
CodeInterpreterTool { type }
type: "code_interpreter"

The type of tool being defined: code_interpreter

FileSearchTool { type, file_search }
type: "file_search"

The type of tool being defined: file_search

One of the following:
FunctionTool { function, type }
function: FunctionDefinition { name, description, parameters, strict }
name: string

The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the function does, used by the model to choose when and how to call the function.

parameters?: FunctionParameters

The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.

Omitting parameters defines a function with an empty parameter list.

strict?: boolean | null

Whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. Learn more about Structured Outputs in the function calling guide.

type: "function"

The type of tool being defined: function

truncation_strategy: TruncationStrategy | null

Controls for how a thread will be truncated prior to the run. Use this to control the initial context window of the run.

type: "auto" | "last_messages"

The truncation strategy to use for the thread. The default is auto. If set to last_messages, the thread will be truncated to the n most recent messages in the thread. When set to auto, messages in the middle of the thread will be dropped to fit the context length of the model, max_prompt_tokens.

One of the following:
"auto"
"last_messages"
last_messages?: number | null

The number of most recent messages from the thread when constructing the context for the run.

minimum1
usage: Usage | null

Usage statistics related to the run. This value will be null if the run is not in a terminal state (i.e. in_progress, queued, etc.).

completion_tokens: number

Number of completion tokens used over the course of the run.

prompt_tokens: number

Number of prompt tokens used over the course of the run.

total_tokens: number

Total number of tokens used (prompt + completion).

temperature?: number | null

The sampling temperature used for this run. If not set, defaults to 1.

top_p?: number | null

The nucleus sampling value used for this run. If not set, defaults to 1.

event: "thread.run.incomplete"
ThreadRunFailed { data, event }

Occurs when a run fails.

data: Run { id, assistant_id, cancelled_at, 24 more }

Represents an execution run on a thread.

id: string

The identifier, which can be referenced in API endpoints.

assistant_id: string

The ID of the assistant used for execution of this run.

cancelled_at: number | null

The Unix timestamp (in seconds) for when the run was cancelled.

completed_at: number | null

The Unix timestamp (in seconds) for when the run was completed.

created_at: number

The Unix timestamp (in seconds) for when the run was created.

expires_at: number | null

The Unix timestamp (in seconds) for when the run will expire.

failed_at: number | null

The Unix timestamp (in seconds) for when the run failed.

incomplete_details: IncompleteDetails | null

Details on why the run is incomplete. Will be null if the run is not incomplete.

reason?: "max_completion_tokens" | "max_prompt_tokens"

The reason why the run is incomplete. This will point to which specific token limit was reached over the course of the run.

One of the following:
"max_completion_tokens"
"max_prompt_tokens"
instructions: string

The instructions that the assistant used for this run.

last_error: LastError | null

The last error associated with this run. Will be null if there are no errors.

code: "server_error" | "rate_limit_exceeded" | "invalid_prompt"

One of server_error, rate_limit_exceeded, or invalid_prompt.

One of the following:
"server_error"
"rate_limit_exceeded"
"invalid_prompt"
message: string

A human-readable description of the error.

max_completion_tokens: number | null

The maximum number of completion tokens specified to have been used over the course of the run.

minimum256
max_prompt_tokens: number | null

The maximum number of prompt tokens specified to have been used over the course of the run.

minimum256
metadata: Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

model: string

The model that the assistant used for this run.

object: "thread.run"

The object type, which is always thread.run.

parallel_tool_calls: boolean

Whether to enable parallel function calling during tool use.

required_action: RequiredAction | null

Details on the action required to continue the run. Will be null if no action is required.

submit_tool_outputs: SubmitToolOutputs { tool_calls }

Details on the tool outputs needed for this run to continue.

tool_calls: Array<RequiredActionFunctionToolCall { id, function, type } >

A list of the relevant tool calls.

id: string

The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the Submit tool outputs to run endpoint.

function: Function { arguments, name }

The function definition.

arguments: string

The arguments that the model expects you to pass to the function.

name: string

The name of the function.

type: "function"

The type of tool call the output is required for. For now, this is always function.

type: "submit_tool_outputs"

For now, this is always submit_tool_outputs.

response_format: AssistantResponseFormatOption | null

Specifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since gpt-3.5-turbo-1106.

Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.

Setting to { "type": "json_object" } enables JSON mode, which ensures the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length.

One of the following:
"auto"
"auto"
ResponseFormatText { type }

Default response format. Used to generate text responses.

type: "text"

The type of response format being defined. Always text.

ResponseFormatJSONObject { type }

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type: "json_object"

The type of response format being defined. Always json_object.

ResponseFormatJSONSchema { json_schema, type }

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

json_schema: JSONSchema { name, description, schema, strict }

Structured Outputs configuration options, including a JSON Schema.

name: string

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the response format is for, used by the model to determine how to respond in the format.

schema?: Record<string, unknown>

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict?: boolean | null

Whether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the schema field. Only a subset of JSON Schema is supported when strict is true. To learn more, read the Structured Outputs guide.

type: "json_schema"

The type of response format being defined. Always json_schema.

started_at: number | null

The Unix timestamp (in seconds) for when the run was started.

status: RunStatus

The status of the run, which can be either queued, in_progress, requires_action, cancelling, cancelled, failed, completed, incomplete, or expired.

One of the following:
"queued"
"in_progress"
"requires_action"
"cancelling"
"cancelled"
"failed"
"completed"
"incomplete"
"expired"
thread_id: string

The ID of the thread that was executed on as a part of this run.

tool_choice: AssistantToolChoiceOption | null

Controls which (if any) tool is called by the model. none means the model will not call any tools and instead generates a message. auto is the default value and means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools before responding to the user. Specifying a particular tool like {"type": "file_search"} or {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.

One of the following:
"none" | "auto" | "required"
"none"
"auto"
"required"
AssistantToolChoice { type, function }

Specifies a tool the model should use. Use to force the model to call a specific tool.

type: "function" | "code_interpreter" | "file_search"

The type of the tool. If type is function, the function name must be set

One of the following:
"function"
"code_interpreter"
"file_search"
function?: AssistantToolChoiceFunction { name }
name: string

The name of the function to call.

tools: Array<AssistantTool>

The list of tools that the assistant used for this run.

One of the following:
CodeInterpreterTool { type }
type: "code_interpreter"

The type of tool being defined: code_interpreter

FileSearchTool { type, file_search }
type: "file_search"

The type of tool being defined: file_search

One of the following:
FunctionTool { function, type }
function: FunctionDefinition { name, description, parameters, strict }
name: string

The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the function does, used by the model to choose when and how to call the function.

parameters?: FunctionParameters

The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.

Omitting parameters defines a function with an empty parameter list.

strict?: boolean | null

Whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. Learn more about Structured Outputs in the function calling guide.

type: "function"

The type of tool being defined: function

truncation_strategy: TruncationStrategy | null

Controls for how a thread will be truncated prior to the run. Use this to control the initial context window of the run.

type: "auto" | "last_messages"

The truncation strategy to use for the thread. The default is auto. If set to last_messages, the thread will be truncated to the n most recent messages in the thread. When set to auto, messages in the middle of the thread will be dropped to fit the context length of the model, max_prompt_tokens.

One of the following:
"auto"
"last_messages"
last_messages?: number | null

The number of most recent messages from the thread when constructing the context for the run.

minimum1
usage: Usage | null

Usage statistics related to the run. This value will be null if the run is not in a terminal state (i.e. in_progress, queued, etc.).

completion_tokens: number

Number of completion tokens used over the course of the run.

prompt_tokens: number

Number of prompt tokens used over the course of the run.

total_tokens: number

Total number of tokens used (prompt + completion).

temperature?: number | null

The sampling temperature used for this run. If not set, defaults to 1.

top_p?: number | null

The nucleus sampling value used for this run. If not set, defaults to 1.

event: "thread.run.failed"
ThreadRunCancelling { data, event }

Occurs when a run moves to a cancelling status.

data: Run { id, assistant_id, cancelled_at, 24 more }

Represents an execution run on a thread.

id: string

The identifier, which can be referenced in API endpoints.

assistant_id: string

The ID of the assistant used for execution of this run.

cancelled_at: number | null

The Unix timestamp (in seconds) for when the run was cancelled.

completed_at: number | null

The Unix timestamp (in seconds) for when the run was completed.

created_at: number

The Unix timestamp (in seconds) for when the run was created.

expires_at: number | null

The Unix timestamp (in seconds) for when the run will expire.

failed_at: number | null

The Unix timestamp (in seconds) for when the run failed.

incomplete_details: IncompleteDetails | null

Details on why the run is incomplete. Will be null if the run is not incomplete.

reason?: "max_completion_tokens" | "max_prompt_tokens"

The reason why the run is incomplete. This will point to which specific token limit was reached over the course of the run.

One of the following:
"max_completion_tokens"
"max_prompt_tokens"
instructions: string

The instructions that the assistant used for this run.

last_error: LastError | null

The last error associated with this run. Will be null if there are no errors.

code: "server_error" | "rate_limit_exceeded" | "invalid_prompt"

One of server_error, rate_limit_exceeded, or invalid_prompt.

One of the following:
"server_error"
"rate_limit_exceeded"
"invalid_prompt"
message: string

A human-readable description of the error.

max_completion_tokens: number | null

The maximum number of completion tokens specified to have been used over the course of the run.

minimum256
max_prompt_tokens: number | null

The maximum number of prompt tokens specified to have been used over the course of the run.

minimum256
metadata: Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

model: string

The model that the assistant used for this run.

object: "thread.run"

The object type, which is always thread.run.

parallel_tool_calls: boolean

Whether to enable parallel function calling during tool use.

required_action: RequiredAction | null

Details on the action required to continue the run. Will be null if no action is required.

submit_tool_outputs: SubmitToolOutputs { tool_calls }

Details on the tool outputs needed for this run to continue.

tool_calls: Array<RequiredActionFunctionToolCall { id, function, type } >

A list of the relevant tool calls.

id: string

The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the Submit tool outputs to run endpoint.

function: Function { arguments, name }

The function definition.

arguments: string

The arguments that the model expects you to pass to the function.

name: string

The name of the function.

type: "function"

The type of tool call the output is required for. For now, this is always function.

type: "submit_tool_outputs"

For now, this is always submit_tool_outputs.

response_format: AssistantResponseFormatOption | null

Specifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since gpt-3.5-turbo-1106.

Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.

Setting to { "type": "json_object" } enables JSON mode, which ensures the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length.

One of the following:
"auto"
"auto"
ResponseFormatText { type }

Default response format. Used to generate text responses.

type: "text"

The type of response format being defined. Always text.

ResponseFormatJSONObject { type }

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type: "json_object"

The type of response format being defined. Always json_object.

ResponseFormatJSONSchema { json_schema, type }

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

json_schema: JSONSchema { name, description, schema, strict }

Structured Outputs configuration options, including a JSON Schema.

name: string

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the response format is for, used by the model to determine how to respond in the format.

schema?: Record<string, unknown>

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict?: boolean | null

Whether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the schema field. Only a subset of JSON Schema is supported when strict is true. To learn more, read the Structured Outputs guide.

type: "json_schema"

The type of response format being defined. Always json_schema.

started_at: number | null

The Unix timestamp (in seconds) for when the run was started.

status: RunStatus

The status of the run, which can be either queued, in_progress, requires_action, cancelling, cancelled, failed, completed, incomplete, or expired.

One of the following:
"queued"
"in_progress"
"requires_action"
"cancelling"
"cancelled"
"failed"
"completed"
"incomplete"
"expired"
thread_id: string

The ID of the thread that was executed on as a part of this run.

tool_choice: AssistantToolChoiceOption | null

Controls which (if any) tool is called by the model. none means the model will not call any tools and instead generates a message. auto is the default value and means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools before responding to the user. Specifying a particular tool like {"type": "file_search"} or {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.

One of the following:
"none" | "auto" | "required"
"none"
"auto"
"required"
AssistantToolChoice { type, function }

Specifies a tool the model should use. Use to force the model to call a specific tool.

type: "function" | "code_interpreter" | "file_search"

The type of the tool. If type is function, the function name must be set

One of the following:
"function"
"code_interpreter"
"file_search"
function?: AssistantToolChoiceFunction { name }
name: string

The name of the function to call.

tools: Array<AssistantTool>

The list of tools that the assistant used for this run.

One of the following:
CodeInterpreterTool { type }
type: "code_interpreter"

The type of tool being defined: code_interpreter

FileSearchTool { type, file_search }
type: "file_search"

The type of tool being defined: file_search

One of the following:
FunctionTool { function, type }
function: FunctionDefinition { name, description, parameters, strict }
name: string

The name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

description?: string

A description of what the function does, used by the model to choose when and how to call the function.

parameters?: FunctionParameters

The parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.

Omitting parameters defines a function with an empty parameter list.

strict?: boolean | null

Whether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the parameters field. Only a subset of JSON Schema is supported when strict is true. Learn more about Structured Outputs in the function calling guide.

type: "function"

The type of tool being defined: function

truncation_strategy: TruncationStrategy | null

Controls for how a thread will be truncated prior to the run. Use this to control the initial context window of the run.

type: "auto" | "last_messages"

The truncation strategy to use for the thread. The default is auto. If set to last_messages, the thread will be truncated to the n most recent messages in the thread. When set to auto, messages in the middle of the thread will be dropped to fit the context length of the model, max_prompt_tokens.

One of the following:
"auto"
"last_messages"
last_messages?: number | null

The number of most recent messages from the thread when constructing the context for the run.

minimum1
usage: Usage | null

Usage statistics related to the run. This value will be null if the run is not in a terminal state (i.e. in_progress, queued, etc.).

completion_tokens: number

Number of completion tokens used over the course of the run.

prompt_tokens: number

Number of prompt tokens used over the course of the run.

total_tokens: number

Total number of tokens used (prompt + completion).

temperature?: number | null

The sampling temperature used for this run. If not set, defaults to 1.

top_p?: number | null

The nucleus sampling value used for this run. If not set, defaults to 1.

event: "thread.run.cancelling"
ThreadRunCancelled { data, event }

Occurs when a run is cancelled.

data: Run { id, assistant_id, cancelled_at, 24 more }

Represents an execution run on a thread.

id: string

The identifier, which can be referenced in API endpoints.

assistant_id: string

The ID of the assistant used for execution of this run.

cancelled_at: number | null

The Unix timestamp (in seconds) for when the run was cancelled.

completed_at: number | null

The Unix timestamp (in seconds) for when the run was completed.

created_at: number

The Unix timestamp (in seconds) for when the run was created.

expires_at: number | null

The Unix timestamp (in seconds) for when the run will expire.

failed_at: number | null

The Unix timestamp (in seconds) for when the run failed.

incomplete_details: IncompleteDetails | null

Details on why the run is incomplete. Will be null if the run is not incomplete.

reason?: "max_completion_tokens" | "max_prompt_tokens"

The reason why the run is incomplete. This will point to which specific token limit was reached over the course of the run.

One of the following:
"max_completion_tokens"
"max_prompt_tokens"
instructions: string

The instructions that the assistant used for this run.

last_error: LastError | null

The last error associated with this run. Will be null if there are no errors.

code: "server_error" | "rate_limit_exceeded" | "invalid_prompt"

One of server_error, rate_limit_exceeded, or invalid_prompt.

One of the following:
"server_error"
"rate_limit_exceeded"
"invalid_prompt"
message: string

A human-readable description of the error.

max_completion_tokens: number | null

The maximum number of completion tokens specified to have been used over the course of the run.

minimum256
max_prompt_tokens: number | null

The maximum number of prompt tokens specified to have been used over the course of the run.

minimum256
metadata: Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

model: string

The model that the assistant used for this run.

object: "thread.run"

The object type, which is always thread.run.

parallel_tool_calls: boolean

Whether to enable parallel function calling during tool use.

required_action: RequiredAction | null

Details on the action required to continue the run. Will be null if no action is required.

submit_tool_outputs: SubmitToolOutputs { tool_calls }

Details on the tool outputs needed for this run to continue.

tool_calls: Array<RequiredActionFunctionToolCall { id, function, type } >

A list of the relevant tool calls.

id: string

The ID of the tool call. This ID must be referenced when you submit the tool outputs in using the Submit tool outputs to run endpoint.

function: Function { arguments, name }

The function definition.

arguments: string

The arguments that the model expects you to pass to the function.

name: string

The name of the function.

type: "function"

The type of tool call the output is required for. For now, this is always function.

type: "submit_tool_outputs"

For now, this is always submit_tool_outputs.

response_format: AssistantResponseFormatOption | null

Specifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since gpt-3.5-turbo-1106.

Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.

Setting to { "type": "json_object" } enables JSON mode, which ensures the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length.

One of the following:
"auto"
"auto"
ResponseFormatText { type }

[...]
